$graph-node-border-radius: 4px;

.graph-node {
    position: absolute;

    border-radius: $graph-node-border-radius;
    display: flex;
    flex-direction: column;

    &.selected {
        box-shadow: 0 0 4px 4px rgba(255, 166, 0, 0.514);
    }

    &.not-selected {
        box-shadow: none;
    }

    .node-header {
        padding: 4px;
        white-space: nowrap;
    }

    .node-grip {
        cursor: move;
    }

    .graph-node-body {
        flex-grow: 1;
        display: flex;
        flex-direction: row;
        align-items: center;

        .node-preview {
            flex-grow: 1;
            flex-shrink: 1;
        }
    }

    .input-port-container {
        display: flex;
        flex-direction: column;
        margin: 4px;

        .port-row {
            display: flex;
            flex-direction: row;

            $endpoint-size: 16px;
            .endpoint {
                min-height: $endpoint-size;
                min-width: $endpoint-size;
                height: $endpoint-size;
                width: $endpoint-size;

                display: inline-block;
                transition: all 0.2s ease-in-out;

                &.input.single {
                    background: radial-gradient(at 50% 100%, #005e9b, rgba(0, 115, 191, 0) 70%) left 50% bottom 0.125em/41%
                            0.125em no-repeat content-box,
                        radial-gradient(at 50% 0, #2b9bd8, rgba(43, 155, 216, 0) 70%) 50% 100%/41% 0.125em no-repeat
                            content-box,
                        radial-gradient(at 90% 0%, rgba(255, 255, 255, 0.2) 50%, rgba(255, 255, 255, 0) 51%) 50%/100%
                            215% border-box,
                        linear-gradient(#2899e9, #0161b0) content-box, linear-gradient(#1a77be, #5bbaf5) border-box;
                }

                &.input.array {
                    background: radial-gradient(at 50% 100%, #059b00, rgba(178, 191, 0, 0) 70%) left 50% bottom 0.125em/41%
                            0.125em no-repeat content-box,
                        radial-gradient(at 50% 0, #00530b, rgba(213, 216, 43, 0) 70%) 50% 100%/41% 0.125em no-repeat
                            content-box,
                        radial-gradient(at 90% 0%, rgba(255, 255, 255, 0.2) 50%, rgba(255, 255, 255, 0) 51%) 50%/100%
                            215% border-box,
                        linear-gradient(#554f00, #0104b0) content-box, linear-gradient(#35be1a, #5bf56f) border-box;
                }

                &.single {
                    border-radius: 0%;
                    border-top-left-radius: 70%;
                    border-bottom-left-radius: 70%;
                }
                &.array {
                    border-radius: 50%;
                }
            }

            .endpoint:hover {
                transform: scale(1.1);
                cursor: crosshair;
            }
        }
    }

    .output-port-container {
        display: flex;
        flex-direction: column;
        margin: 4px;

        .port-row {
            display: flex;
            flex-direction: row;

            $endpoint-size: 16px;
            .endpoint {
                min-height: $endpoint-size;
                min-width: $endpoint-size;
                height: $endpoint-size;
                width: $endpoint-size;

                display: inline-block;
                transition: all 0.2s ease-in-out;

                &.output.array {
                    background: radial-gradient(at 50% 100%, #00969b, rgba(0, 115, 191, 0) 70%) left 50% bottom 0.125em/41%
                            0.125em no-repeat content-box,
                        radial-gradient(at 50% 0, #2bbed8, rgba(216, 135, 43, 0) 70%) 50% 100%/41% 0.125em no-repeat
                            content-box,
                        radial-gradient(at 90% 0%, rgba(255, 255, 255, 0.2) 50%, rgba(255, 255, 255, 0) 51%) 50%/100%
                            215% border-box,
                        linear-gradient(#28d3e9, #01b0b0) content-box, linear-gradient(#1a90be, #e35bf5) border-box;
                }

                &.output.single {
                    background: radial-gradient(at 50% 100%, #3e9b00, rgba(0, 115, 191, 0) 70%) left 50% bottom 0.125em/41%
                            0.125em no-repeat content-box,
                        radial-gradient(at 50% 0, #d85c2b, rgba(216, 135, 43, 0) 70%) 50% 100%/41% 0.125em no-repeat
                            content-box,
                        radial-gradient(at 90% 0%, rgba(255, 255, 255, 0.2) 50%, rgba(255, 255, 255, 0) 51%) 50%/100%
                            215% border-box,
                        linear-gradient(#042c09, #01b00a) content-box, linear-gradient(#1fbe1a, #f55b5b) border-box;
                }

                &.single {
                    border-radius: 0%;
                    border-top-right-radius: 70%;
                    border-bottom-right-radius: 70%;
                }

                &.array {
                    border-radius: 50%;
                }
            }

            .endpoint:hover {
                transform: scale(1.1);
                cursor: crosshair;
            }
        }
    }
}
